# $Revision: 1.14 $, $Date: 2008/07/27 22:15:23 $
Summary:	A tool for trace and analyze memory leaks in C++ programs
Summary(pl.UTF-8):	Narzędzie do śledzenia i analizowania wycieków pamięci w programach w C++
Name:		LeakTracer
Version:	2.4
Release:	2
License:	Public Domain
Group:		Applications
Source0:	http://www.andreasen.org/LeakTracer/LeakTracer.tar.gz
# Source0-md5:	e1cf9d03c12a45d39f253e558d231438
Patch0:		%{name}-Makefile.patch
Patch1:		%{name}-64bit.patch
Patch2:		%{name}-caller_addr.patch
URL:		http://www.andreasen.org/LeakTracer/
BuildRequires:	gcc-c++
BuildRequires:	sed >= 4.0
Requires:	gdb
ExcludeArch:	alpha arm mips
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
LeakTracer is a small tool for checking a C++ program for memory
leaks. To use LeakTracer, run your program using the provided
LeakCheck script. It uses the LD_PRELOAD feature to "overlay" some
functions on top of your functions (no recompile needed). leak-analyze
uses gdb to print out the exact line where the memory was allocated
and not freed - this of course means you have to free all dynamically
allocated data. LeakTracer also overrides the global operator new and
operator delete - this will give problems if you override them as
well. LeakTracer traces only new/new[] and delete calls - it does not
look at malloc/free/realloc.

%description -l pl.UTF-8
LeakTracer to małe narzędzie do sprawdzania programów w C++ pod kątem
wycieków pamięci. Aby go użyć na jakimś programie, trzeba uruchomić
ten program przy użyciu załączonego skryptu LeakCheck. Używa on
LD_PRELOAD do przykrycia niektórych funkcji (rekompilacja nie jest
potrzebna). leak-analyze używa gdb do pokazania w których dokładnie
liniach pamięć została przydzielona i nie zwolniona - co oznacza, że
trzeba zwolnić wszystkie dynamicznie przydzielone dane. LeakTracer
przykrywa także globalne operatory new i delete - może to spowodować
problemy, jeśli my także chcemy je przykryć. LeakTracer śledzi tylko
wywołania new/new[] i delete - nie patrzy na malloc/free/realloc.

%prep
%setup -q -n %{name}
%patch0 -p1
%patch1 -p0
%patch2 -p0

%build
sed -i "s:SHLIB=.*:SHLIB=%{_libdir}/LeakTracer.so:" LeakCheck

%{__make} \
	CXX="%{__cxx}" \
	CXXFLAGS="%{rpmcxxflags} -nodefaultlibs -O1 -fno-omit-frame-pointer"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir}}

install leak-analyze	$RPM_BUILD_ROOT%{_bindir}
install LeakCheck	$RPM_BUILD_ROOT%{_bindir}
install LeakTracer.so	$RPM_BUILD_ROOT%{_libdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc README
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_libdir}/*.so

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: LeakTracer.spec,v $
Revision 1.14  2008/07/27 22:15:23  arekm
- release 2

Revision 1.13  2007-02-12 21:21:31  glen
- tabs in preamle

Revision 1.12  2007/02/12 00:48:33  baggins
- converted to UTF-8

Revision 1.11  2005/12/11 13:17:27  pluto
- exclude arch : alpha, arm, mips due to problems with __builtin_return_address.

Revision 1.10  2005/12/11 12:35:48  qboosh
- typo

Revision 1.9  2005/12/11 09:38:08  qboosh
- pl, BR: gcc-c++

Revision 1.8  2005/12/11 00:59:51  pluto
- BR:libstdc++-devel reverted. use -O1 -fno-omit-frame-pointer to avoid
  unreliable results from __builtin_return_address. now it works fine
  on amd64.

Revision 1.7  2005/12/11 00:13:46  pluto
- readded BR:libstdc++-devel.

Revision 1.6  2005/12/11 00:10:35  pluto
- yep, -lstdc++ is needed on amd64.
- version changed to 2.4 (based on web annonunce).

Revision 1.5  2005/12/11 00:02:39  pluto
- fix amd64 version.
- use caller address instead of reaturn address (proper src. line loc.).

Revision 1.4  2005/12/10 20:43:07  pluto
- pass rpmcxxflags.

Revision 1.3  2005/12/10 20:42:12  pluto
- it doesn't req. libstdc++. just omit -lstdc++ from linking.

Revision 1.2  2005/12/10 20:25:35  darekr
- BR: libstdc++-devel

Revision 1.1  2005/12/10 16:23:45  pluto
- simple and useful tool for hunting mem leaks.
